<template>
  <div class="container">
    <h2>Calculator A</h2>
    <br />
    <div class="grid-container">
      <div class="result">{{ resultScreenText }}</div>
      <div class="operation">{{ operationScreenText }}</div>
      <div class="grid-item" @click="clear()">C</div>
      <div class="grid-item" @click="setValue('x')">x</div>
      <div class="grid-item" @click="setValue('-')">-</div>
      <div class="grid-item plus" @click="setValue('+')">+</div>
      <div class="grid-item" @click="setValue('7')">7</div>
      <div class="grid-item" @click="setValue('8')">8</div>
      <div class="grid-item" @click="setValue('9')">9</div>
      <div class="grid-item" @click="setValue('4')">4</div>
      <div class="grid-item" @click="setValue('5')">5</div>
      <div class="grid-item" @click="setValue('6')">6</div>
      <div class="grid-item equal" @click="computation()">=</div>
      <div class="grid-item" @click="setValue('1')">1</div>
      <div class="grid-item" @click="setValue('2')">2</div>
      <div class="grid-item" @click="setValue('3')">3</div>
      <div class="grid-item zero" @click="setValue('0')">0</div>
      <div class="grid-item" @click="setValue('.')">.</div>
    </div>
  </div>
</template>

<script>
import axios from "axios";

export default {
  name: "CalculatorA",
  data() {
    return {
      resultScreenText: "0",
      operationScreenText: "0",
      value: "",
      result: "",
      operation: "",
      operator: "",
      list: {},
      historyList: [],
      data_history: [],
      date: new Date(),
    };
  },
  methods: {
    setValue(value) {
      if (this.operationScreenText === "0") {
        if (value === "." || value === "+" || value === "-" || value === "x") {
          this.operationScreenText += value;
          this.operationoperation = "0" + value;
        } else {
          this.operationScreenText = value;
          this.operation = value;
        }
      } else {
        if (
          (this.operator[1] === "+" ||
            this.operator[1] === "-" ||
            this.operator[1] === "x" ||
            this.operator[1] === ".") &&
          (value === "+" || value === "-" || value === "x" || value === ".")
        ) {
          this.operationScreenText =
            this.operationScreenText.slice(0, -1) + value;
          if (this.operator[1] === "+") {
            this.operation = this.operation.slice(0, -3);
            if (value === "+") {
              this.value = "%2B";
              this.operation = this.operation + this.value;
            } else if (value === "x") {
              this.value = "*";
              this.operation = this.operation + this.value;
            } else {
              this.operation = this.operation + value;
            }
          }
          if (this.operator[1] === "-") {
            this.operation = this.operation.slice(0, -1);
            if (value === "+") {
              this.value = "%2B";
              this.operation = this.operation + this.value;
            } else if (value === "x") {
              this.value = "*";
              this.operation = this.operation + this.value;
            } else {
              this.operation = this.operation + value;
            }
          }
          if (this.operator[1] === "x") {
            this.operation = this.operation.slice(0, -1);
            if (value === "+") {
              this.value = "%2B";
              this.operation = this.operation + this.value;
            } else if (value === "x") {
              this.value = "*";
              this.operation = this.operation + this.value;
            } else {
              this.operation = this.operation + value;
            }
          }
          if (this.operator[1] === ".") {
            this.operation = this.operation.slice(0, -1);
            if (value === ".") {
              this.operation = this.operation + value;
            }
          }
        } else {
          if (value === "+") {
            this.value = "%2B";
            this.operation = this.operation + this.value;
          } else if (value === "x") {
            this.value = "*";
            this.operation = this.operation + this.value;
          } else {
            this.operation = this.operation + value;
          }
          this.operationScreenText = this.operationScreenText + value;
        }
      }
      // check Point
      if (value === ".") {
        let point = this.operationScreenText.split("");
        for (let i = point.length - 1; i >= 0; i--) {
          if (point[point.length - 1] === "." && point[i - 1] === ".") {
            this.operationScreenText = this.operationScreenText.slice(0, -1);
            this.operation = this.operation.slice(0, -1);
          }
          if (point[i] === "+" || point[i] === "-" || point[i] === "x") {
            break;
          }
        }
      }
      //  check Zero
      let checkZero = this.operationScreenText.split("");
      if (
        checkZero[checkZero.length - 1] !== "." &&
        checkZero[checkZero.length - 2] === "0" &&
        (checkZero[checkZero.length - 3] === "+" ||
          checkZero[checkZero.length - 3] === "-" ||
          checkZero[checkZero.length - 3] === "x") &&
        (value !== "+" || value !== "-" || value !== "x")
      ) {
        this.operationScreenText = this.operationScreenText.slice(0, -2);
        this.operation = this.operation.slice(0, -2);
        this.operationScreenText += value;
        this.operation += value;
      }

      this.operator = this.operationScreenText.split(
        this.operationScreenText.slice(0, -1)
      );
    },
    clear() {
      this.resultScreenText = "0";
      this.operationScreenText = "0";
      this.value = "";
      this.operation = "";
      this.operator = "";
    },
    computation() {
      axios
        .get("https://api.mathjs.org/v4/?expr=" + this.operation)
        .then((res) => {
          this.result = res.data;
          this.resultScreenText = this.result;
          this.list = {};
          this.list = {
            name: "Calculator A",
            result: this.resultScreenText,
            operation: this.operationScreenText,
            date:
              this.date.getDate().toString() +
              "/" +
              this.date.getMonth().toString() +
              "/" +
              this.date.getFullYear().toString() +
              "-" +
              this.date.getHours().toString() +
              ":" +
              this.date.getMinutes().toString() +
              "." +
              this.date.getSeconds().toString(),
          };

          this.setData(this.list);
        })
        .catch((error) => {
          console.error(error);
        });
    },
    setData(data) {
      if (JSON.parse(localStorage.getItem("historyList"))) {
        this.data_history = JSON.parse(localStorage.getItem("historyList"));
        this.data_history.push(data);
        this.historyList = this.data_history;
      } else {
        this.historyList.push(data);
      }
      localStorage.setItem("historyList", JSON.stringify(this.historyList));
      location.reload();
    },
  },
};
</script>

<style scoped>
.grid-container {
  display: grid;
  grid-template-columns: auto auto auto auto;
  grid-gap: 10px;
  background-color: white;
  padding: 7%;
  width: 100%;
  height: 100%;
  border-color: black;
  border-radius: 20px;
}
.grid-item {
  background-color: #a7d4fa;
  border: 1px solid #a7d4fa;
  padding: 10%;
  font-size: 30px;
  display: flex;
  justify-content: center;
  align-items: center;
  border-radius: 15px;
  /* Prevent copying text in web-page */
  -webkit-touch-callout: none; /* iOS Safari */
  -webkit-user-select: none; /* Safari */
  -khtml-user-select: none; /* Konqueror HTML */
  -moz-user-select: none; /* Old versions of Firefox */
  -ms-user-select: none; /* Internet Explorer/Edge */
  user-select: none; /* Non-prefixed version, currently supported by Chrome, Edge, Opera and Firefox */
  /* -------------------------------- */
}
.plus {
  grid-area: 3/4/5/5;
}
.equal {
  grid-area: 5/4/8/5;
}
.zero {
  grid-area: 7/1/8/3;
}
.grid-item:hover {
  background-color: #d6eaf8;
}
.grid-item:active {
  background-color: #85c1e9;
}
.result {
  font-size: 50px;
  grid-area: 1/1/2/5;
  color: #707070;
}
.operation {
  font-size: 30px;
  grid-area: 2/1/3/5;
  color: #707070;
}
h2 {
  color: #707070;
}
</style>
